找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 947|回复: 2

[ARX程序]:请教XD:AcDbBlockRefence的插入的转换矩阵是什么?

[复制链接]
发表于 2002-3-26 09:57:24 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
AcDbBlockRefence的插入的转换矩阵是什么,知道插入实体块的组成实体的相对坐标后怎样转换成INSERT示例上的点?谢谢!
下面是获得各个实体的点:
ads_name ss;
ads_point pt;
if(acedEntSel(NULL,ss,pt)!=RTNORM)
    return ;
AcDbObjectId ObjId;
acdbGetObjectId(ObjId,ss);
AcDbBlockReference *BlockRef;
acdbOpenObject(BlockRef,ObjId,AcDb::kForRead);
if(BlockRef!=NULL)
{
   AcDbObjectId id=BlockRef->blockTableRecord();
   AcDbBlockTableRecord *BlockRec;
   acdbOpenObject(BlockRec,id,AcDb::kForRead);
   if(BlockRec!=NULL)
   {
      AcDbBlockTableRecordIterator *pBlockIterator;
      BlockRec->newIterator(pBlockIterator);
      for(;!pBlockIterator->done();
                  pBlockIterator->step())
      {
        AcDbEntity *pEntity;
        pBlockIterator->getEntity(pEntity,AcDb::kForRead);
        AcDbCurve *pline;
        acdbOpenObject(pline,pEntity->objectId(),AcDb::kForRead);
        if(pline!=NULL)
        {//遍历块上所有实体的点
           AcGePoint3d ePt,sPt;
           pline->getStartPoint(sPt);
           pline->getEndPoint(ePt);
             CString Str,Str1;
           Str.Format("X=%f,Y=%f,Z=%f",ePt[X],ePt[Y],ePt[Z]);
        Str1.Format("\nX=%f,Y=%f,Z=%f",sPt[X],sPt[Y],sPt[Z]);
        Str+=Str1;
        AfxMessageBox(Str);
      }
      pline->close();
  }
}
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 145个

财富等级: 日进斗金

发表于 2002-3-26 10:15:09 | 显示全部楼层
AcGeBlockRefrence::blockTransform(...)见下面用法

AcGeMatrix3d

blockTransform() const;

Returns a matrix that describes the mapping from the block table record's MCS (the WCS within the block table record抯 microspace) out to the AcDbDatabase's WCS.
So, for example, applying this matrix to the center point value of a circle within the block table record will generate the center point of the circle as displayed for the block reference.

写程序前,多看看联机帮助,帮助是个宝库,一个类的所有方法都会找到,这个类里面没有找到,那就试试到基类去找。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 145个

财富等级: 日进斗金

发表于 2002-3-26 10:20:01 | 显示全部楼层
得到转换矩阵后,把它作用到你的3D点(AcGePoint3d)上就可以了。

AcGePoint3d::transformBy(...)  见下面

AcGePoint3d&
transformBy(

    const AcGeMatrix3d& leftSide);

leftSide        Input transform matrix

Transform this pre-multiplying it the matrix mat.
Returns the reference to this point.
Result is the same as setToProduct(mat, *this).
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-11-16 04:37 , Processed in 0.395618 second(s), 35 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表